// LessonA07Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "LessonA07.h"
#include "LessonA07Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLessonA07Dlg dialog

CLessonA07Dlg::CLessonA07Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLessonA07Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLessonA07Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLessonA07Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLessonA07Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLessonA07Dlg, CDialog)
	//{{AFX_MSG_MAP(CLessonA07Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLessonA07Dlg message handlers

BOOL CLessonA07Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//CRect rt;
	
	// chart 1
	m_Chart[0].CreateChart(kTypeXY);
	
	for(int i=-10; i<=10; i++)
	{
		m_Chart[0].AddPoint2D(i, i*i);
	}
	
	m_pWnd[0] = GetDlgItem(IDC_CHART1);
	//m_pWnd[0]->GetClientRect(&rt);
	//m_Chart[0].SetConfineRect(rt);
	
	m_Chart[0].SetBkgndColor(GetSysColor(COLOR_3DFACE));
	
	// chart 2
	m_Chart[1].CreateChart(kTypePie);
	
	m_Chart[1].AddPie(2, "ÁõÑÒ");
	m_Chart[1].AddPie(2, "öÄÓ±");
	m_Chart[1].AddPie(4, "ÖÜÑ¸");
	m_Chart[1].AddPie(8, "Íõ·Æ");
	
	m_pWnd[1] = GetDlgItem(IDC_CHART2);
	//m_pWnd[1]->GetClientRect(&rt);
	//m_Chart[1].SetConfineRect(rt);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLessonA07Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLessonA07Dlg::OnPaint() 
{
	int i;
	for(i=0; i<2; i++)
	{
		m_Chart[i].OnDraw(m_pWnd[i]->m_hWnd);
	}

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLessonA07Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CLessonA07Dlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	CRect rect;
	CPoint pt;
	CWnd *pWnd;
	int i;
	if(pMsg->message==WM_LBUTTONDOWN)
	{
		for(i=0; i<2; i++)
		{
			pWnd=m_pWnd[i];
			pWnd->GetWindowRect(&rect);
			if (rect.PtInRect(pMsg->pt))
			{
				pt = pMsg->pt;
				pWnd->ScreenToClient(&pt);
				m_Chart[i].OnLButtonDownR(pWnd->m_hWnd, pt, 0);
			} 
		}
	}
	else if(pMsg->message==WM_LBUTTONUP)
	{
		for(i=0; i<2; i++)
		{
			pWnd=m_pWnd[i];
			pWnd->GetWindowRect(&rect);
			if (rect.PtInRect(pMsg->pt))
			{
				pt = pMsg->pt;
				pWnd->ScreenToClient(&pt);
				m_Chart[i].OnLButtonUpR(pWnd->m_hWnd, pt, 0);
			} 
		}
	}
	else if(pMsg->message==WM_LBUTTONDBLCLK)
	{
		for(i=0; i<2; i++)
		{
			pWnd=m_pWnd[i];
			pWnd->GetWindowRect(&rect);
			if (rect.PtInRect(pMsg->pt))
			{
				pt = pMsg->pt;
				pWnd->ScreenToClient(&pt);
				m_Chart[i].OnLButtonDblClkR(pWnd->m_hWnd, pt, 0);
			} 
		}
	}
	else if(pMsg->message==WM_MOUSEMOVE)
	{
		for(i=0; i<2; i++)
		{
			pWnd=m_pWnd[i];
			pWnd->GetWindowRect(&rect);
			if (rect.PtInRect(pMsg->pt))
			{
				pt = pMsg->pt;
				pWnd->ScreenToClient(&pt);
				m_Chart[i].OnMouseMoveR(pWnd->m_hWnd, pt, 0);
			} 
		}
	}
	else if(pMsg->message==WM_RBUTTONDOWN)
	{
		for(i=0; i<2; i++)
		{
			pWnd=m_pWnd[i];
			pWnd->GetWindowRect(&rect);
			if (rect.PtInRect(pMsg->pt))
			{
				pt = pMsg->pt;
				//pWnd->ScreenToClient(&pt);
				m_Chart[i].OnContextMenuR(NULL, pWnd->m_hWnd, pt);
			} 
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}
